﻿
Module Module1

 
    Dim GlobalByteArray() As Byte
    Public GlobalByteArraySize As Long
    Dim GlobalNumberOfTicksInOneSecond As Long
    Public GlobalDiffTime As Decimal
    Public GlobalTestRunning As Boolean
    Public GlobalFlushMemory As Boolean
    Public GlobalRandomizeMemory As Boolean
    Public GlobalPauseTime As Integer
    Public GlobalSampleSize As Long
    Dim GlobalSampleArray() As Long
    Declare Function GetTickCount Lib "kernel32" () As Long
    Private Declare Sub Sleep Lib "kernel32" Alias "Sleep" (ByVal dwMilliseconds As Long)
    Declare Function QueryPerformanceCounter Lib "Kernel32" (ByRef X As Long) As Short
    Declare Function QueryPerformanceFrequency Lib "Kernel32" (ByRef X As Long) As Short




    Public Sub ThreadTask()
        Dim Ctr1, Ctr2, Freq As Long
        Dim TempByte As Byte

        QueryPerformanceFrequency(Freq)

        ReDim GlobalByteArray(GlobalByteArraySize)
        ReDim GlobalSampleArray(GlobalSampleSize)
        Dim iTarget As Long
        iTarget = Random(0, 4096)
        For i = 0 To GlobalByteArraySize - 1
            GlobalByteArray(i) = 0
            If i = iTarget Then
                GlobalByteArray(i) = Random(0, 250)
                iTarget = i + CInt(Random(0, 4096))
            End If
        Next
        While GlobalTestRunning
            For i = 0 To GlobalSampleSize
                GlobalSampleArray(i) = Random(0, GlobalByteArraySize - 1)
            Next
            QueryPerformanceCounter(Ctr1)
            For i = 0 To GlobalSampleSize
                TempByte = GlobalByteArray(GlobalSampleArray(i))
                If i < (GlobalSampleSize / 10) Then
                    GlobalByteArray(GlobalSampleArray(i)) = GlobalByteArray(GlobalSampleArray(i)) Xor 1
                End If
            Next
            QueryPerformanceCounter(Ctr2)
            GlobalDiffTime = NewAverage((((GlobalSampleSize * 4) / (1024 * 1024))) * (Freq / (Ctr2 - Ctr1)))
            Sleep(GlobalPauseTime)
            If GlobalFlushMemory Then
                For i = 0 To GlobalByteArraySize - 1
                    GlobalByteArray(i) = 0
                Next
                GlobalFlushMemory = False
            End If
            If GlobalRandomizeMemory Then
                iTarget = Random(0, 4096)
                For i = 0 To GlobalByteArraySize - 1
                    GlobalByteArray(i) = 0
                    If i = iTarget Then
                        GlobalByteArray(i) = Random(0, 250)
                        iTarget = i + CInt(Random(0, 4096))
                    End If
                Next
                GlobalRandomizeMemory = False
            End If
        End While



    End Sub

    Function Random(ByVal Lowerbound As Long, ByVal Upperbound As Long) As Long
        Randomize()
        Random = Int(Rnd() * Upperbound) + Lowerbound
    End Function



    Dim NewAverageArray(20) As Decimal
    Dim NewAverageArraySorted(20) As Decimal
    Public Function NewAverage(ByVal NewEntry As Decimal) As Decimal
        ' Pop in newentry
        For j = 20 To 1 Step -1
            NewAverageArray(j) = NewAverageArray(j - 1)
        Next
        NewAverageArray(0) = NewEntry
        Array.Copy(NewAverageArray, NewAverageArraySorted, NewAverageArray.Length)
        Array.Sort(NewAverageArraySorted)
        NewAverage = (NewAverageArraySorted(8) + NewAverageArraySorted(9) + NewAverageArraySorted(10) + NewAverageArraySorted(11) + NewAverageArraySorted(12)) / 5
    End Function


End Module
